#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _stream_engine_svc_stream_engine_object_info;

struct _StreamEngineSvcStreamEngineClass {
    GTypeInterface parent_class;
    stream_engine_svc_stream_engine_get_output_window_impl get_output_window;
    stream_engine_svc_stream_engine_create_preview_window_impl create_preview_window;
    stream_engine_svc_stream_engine_get_preview_window_impl get_preview_window;
    stream_engine_svc_stream_engine_shutdown_impl shutdown;
    stream_engine_svc_stream_engine_attach_to_channel_impl attach_to_channel;
};

enum {
    SIGNAL_STREAM_ENGINE_Receiving,
    N_STREAM_ENGINE_SIGNALS
};
static guint stream_engine_signals[N_STREAM_ENGINE_SIGNALS] = {0};

static void stream_engine_svc_stream_engine_base_init (gpointer klass);

GType
stream_engine_svc_stream_engine_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (StreamEngineSvcStreamEngineClass),
        stream_engine_svc_stream_engine_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "StreamEngineSvcStreamEngine", &info, 0);
    }

  return type;
}

/**
 * stream_engine_svc_stream_engine_get_output_window_impl:
 * @self: The object implementing this interface
 * @in_channel_path: const gchar * (FIXME, generate documentation)
 * @in_stream_id: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetOutputWindow on interface org.maemo.Telepathy.StreamEngine.
 */
static void
stream_engine_svc_stream_engine_get_output_window (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    DBusGMethodInvocation *context)
{
  stream_engine_svc_stream_engine_get_output_window_impl impl = (STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS (self)->get_output_window);

  if (impl != NULL)
    {
      (impl) (self,
        in_channel_path,
        in_stream_id,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * stream_engine_svc_stream_engine_implement_get_output_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetOutputWindow D-Bus method
 *
 * Register an implementation for the GetOutputWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
stream_engine_svc_stream_engine_implement_get_output_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_get_output_window_impl impl)
{
  klass->get_output_window = impl;
}

/**
 * stream_engine_svc_stream_engine_create_preview_window_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * CreatePreviewWindow on interface org.maemo.Telepathy.StreamEngine.
 */
static void
stream_engine_svc_stream_engine_create_preview_window (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context)
{
  stream_engine_svc_stream_engine_create_preview_window_impl impl = (STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS (self)->create_preview_window);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * stream_engine_svc_stream_engine_implement_create_preview_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CreatePreviewWindow D-Bus method
 *
 * Register an implementation for the CreatePreviewWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
stream_engine_svc_stream_engine_implement_create_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_create_preview_window_impl impl)
{
  klass->create_preview_window = impl;
}

/**
 * stream_engine_svc_stream_engine_get_preview_window_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetPreviewWindow on interface org.maemo.Telepathy.StreamEngine.
 */
static void
stream_engine_svc_stream_engine_get_preview_window (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context)
{
  stream_engine_svc_stream_engine_get_preview_window_impl impl = (STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS (self)->get_preview_window);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * stream_engine_svc_stream_engine_implement_get_preview_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPreviewWindow D-Bus method
 *
 * Register an implementation for the GetPreviewWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
stream_engine_svc_stream_engine_implement_get_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_get_preview_window_impl impl)
{
  klass->get_preview_window = impl;
}

/**
 * stream_engine_svc_stream_engine_shutdown_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Shutdown on interface org.maemo.Telepathy.StreamEngine.
 */
static void
stream_engine_svc_stream_engine_shutdown (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context)
{
  stream_engine_svc_stream_engine_shutdown_impl impl = (STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS (self)->shutdown);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * stream_engine_svc_stream_engine_implement_shutdown:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Shutdown D-Bus method
 *
 * Register an implementation for the Shutdown method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
stream_engine_svc_stream_engine_implement_shutdown (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_shutdown_impl impl)
{
  klass->shutdown = impl;
}

/**
 * stream_engine_svc_stream_engine_attach_to_channel_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel_Type: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AttachToChannel on interface org.maemo.Telepathy.StreamEngine.
 */
static void
stream_engine_svc_stream_engine_attach_to_channel (StreamEngineSvcStreamEngine *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  stream_engine_svc_stream_engine_attach_to_channel_impl impl = (STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS (self)->attach_to_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel_Type,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * stream_engine_svc_stream_engine_implement_attach_to_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AttachToChannel D-Bus method
 *
 * Register an implementation for the AttachToChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
stream_engine_svc_stream_engine_implement_attach_to_channel (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_attach_to_channel_impl impl)
{
  klass->attach_to_channel = impl;
}

/**
 * stream_engine_svc_stream_engine_emit_receiving:
 * @instance: The object implementing this interface
 * @arg_channel_path: const gchar * (FIXME, generate documentation)
 * @arg_stream_id: guint  (FIXME, generate documentation)
 * @arg_state: gboolean  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Receiving signal on interface org.maemo.Telepathy.StreamEngine.
 */
void
stream_engine_svc_stream_engine_emit_receiving (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE));
  g_signal_emit (instance,
      stream_engine_signals[SIGNAL_STREAM_ENGINE_Receiving],
      0,
      arg_channel_path,
      arg_stream_id,
      arg_state);
}

static inline void
stream_engine_svc_stream_engine_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.maemo.Telepathy.StreamEngine");
  tp_svc_interface_set_dbus_properties_info (STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE, &interface);

  stream_engine_signals[SIGNAL_STREAM_ENGINE_Receiving] =
  g_signal_new ("receiving",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _se_api_marshal_VOID__BOXED_UINT_BOOLEAN,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_UINT,
      G_TYPE_BOOLEAN);

  dbus_g_object_type_install_info (stream_engine_svc_stream_engine_get_type (),
      &_stream_engine_svc_stream_engine_object_info);
}
static void
stream_engine_svc_stream_engine_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      stream_engine_svc_stream_engine_base_init_once (klass);
    }
}
static const DBusGMethodInfo _stream_engine_svc_stream_engine_methods[] = {
  { (GCallback) stream_engine_svc_stream_engine_get_output_window, _se_api_marshal_VOID__BOXED_UINT_POINTER, 0 },
  { (GCallback) stream_engine_svc_stream_engine_create_preview_window, g_cclosure_marshal_VOID__POINTER, 98 },
  { (GCallback) stream_engine_svc_stream_engine_get_preview_window, g_cclosure_marshal_VOID__POINTER, 169 },
  { (GCallback) stream_engine_svc_stream_engine_shutdown, g_cclosure_marshal_VOID__POINTER, 237 },
  { (GCallback) stream_engine_svc_stream_engine_attach_to_channel, _se_api_marshal_VOID__STRING_BOXED_STRING_BOXED_UINT_UINT_POINTER, 282 },
};

static const DBusGObjectInfo _stream_engine_svc_stream_engine_object_info = {
  0,
  _stream_engine_svc_stream_engine_methods,
  5,
"org.maemo.Telepathy.StreamEngine\0GetOutputWindow\0A\0channel_path\0I\0o\0stream_id\0I\0u\0window\0O\0F\0N\0u\0\0org.maemo.Telepathy.StreamEngine\0CreatePreviewWindow\0A\0window\0O\0F\0N\0u\0\0org.maemo.Telepathy.StreamEngine\0GetPreviewWindow\0A\0window\0O\0F\0N\0u\0\0org.maemo.Telepathy.StreamEngine\0Shutdown\0A\0\0org.maemo.Telepathy.StreamEngine\0AttachToChannel\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel_Type\0I\0s\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"org.maemo.Telepathy.StreamEngine\0Receiving\0\0",
"\0\0",
};


