#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * StreamEngineSvcStreamEngine:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _StreamEngineSvcStreamEngine StreamEngineSvcStreamEngine;

/**
 * StreamEngineSvcStreamEngineClass:
 *
 * The class of StreamEngineSvcStreamEngine.
 */
typedef struct _StreamEngineSvcStreamEngineClass StreamEngineSvcStreamEngineClass;

GType stream_engine_svc_stream_engine_get_type (void);
#define STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE \
  (stream_engine_svc_stream_engine_get_type ())
#define STREAM_ENGINE_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE, StreamEngineSvcStreamEngine))
#define STREAM_ENGINE_IS_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE))
#define STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE, StreamEngineSvcStreamEngineClass))


typedef void (*stream_engine_svc_stream_engine_get_output_window_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_get_output_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_get_output_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_get_output_window:
 * @context: The D-Bus method invocation context
 * @out_window: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_get_output_window (DBusGMethodInvocation *context,
    guint out_window);
static inline void
stream_engine_svc_stream_engine_return_from_get_output_window (DBusGMethodInvocation *context,
    guint out_window)
{
  dbus_g_method_return (context,
      out_window);
}

typedef void (*stream_engine_svc_stream_engine_create_preview_window_impl) (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_create_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_create_preview_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_create_preview_window:
 * @context: The D-Bus method invocation context
 * @out_window: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_create_preview_window (DBusGMethodInvocation *context,
    guint out_window);
static inline void
stream_engine_svc_stream_engine_return_from_create_preview_window (DBusGMethodInvocation *context,
    guint out_window)
{
  dbus_g_method_return (context,
      out_window);
}

typedef void (*stream_engine_svc_stream_engine_get_preview_window_impl) (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_get_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_get_preview_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_get_preview_window:
 * @context: The D-Bus method invocation context
 * @out_window: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_get_preview_window (DBusGMethodInvocation *context,
    guint out_window);
static inline void
stream_engine_svc_stream_engine_return_from_get_preview_window (DBusGMethodInvocation *context,
    guint out_window)
{
  dbus_g_method_return (context,
      out_window);
}

typedef void (*stream_engine_svc_stream_engine_shutdown_impl) (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_shutdown (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_shutdown_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_shutdown:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_attach_to_channel_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_attach_to_channel (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_attach_to_channel_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_attach_to_channel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_attach_to_channel (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_attach_to_channel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void stream_engine_svc_stream_engine_emit_receiving (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state);


G_END_DECLS
